#ifndef MAIN_h
#define MAIN_h

#define LED_DDR     DDRB
#define LED_PORT    PORTB
#define LED_PIN     PB5

static const char __flash p_off[] = " -.-- ";

void lcd_uint16_unit( const uint16_t value, const char unit );
void lastline(void);

uint8_t display_norm_init( void );
uint8_t display_norm_waitkey( void );
uint8_t display_menu_init( uint8_t *mp );
uint8_t display_menu_changed( const uint8_t *mp );
uint8_t display_menu_waitkey( uint8_t *mp );
uint8_t display_val_init( uint8_t *mp);
uint8_t display_val_changed( void );
uint8_t display_val_waitkey(  uint8_t *mp);
// max 65535 == 65.535

#define VAL_AMPS 0
#define VAL_VOLT 1
#define VAL_WATT 2
#define VAL_NONE 255

uint16_t val_cur[3] = { 0xffff, 0xffff, 0xffff };
uint16_t val_set[3] = { 0x0000, 0x0000, 0x0000 };

const char val_unit[] = { 'A', 'V', 'W' };

const uint16_t powten[] = {
    10000,
     1000,
      100,
       10,
        1
};

// extern uint8_t display;
#define DISPLAY_NORM_INIT   0
#define DISPLAY_NORM_WAITKEY    1
#define DISPLAY_MENU_INIT       10
#define DISPLAY_MENU_CHANGED    11
#define DISPLAY_MENU_WAITKEY    12
#define DISPLAY_VAL_INIT        20
#define DISPLAY_VAL_CHANGED     21
#define DISPLAY_VAL_WAITKEY     22

extern uint8_t menuepos;

extern volatile uint8_t cur_mode;
// 0 0 0 0 0 y y x
// x (in)active
// y amp/volt/watt mode
#define CUR_MODE_MASK_ACTIVE    0x01
#define CUR_MODE_IS_ACTIVE      1
#define CUR_MODE_CONST_SHIFT    1
#define CUR_MODE_CONST_MASK     0x06
#define CUR_MODE_CONST_IS_AMPS  ( VAL_AMPS << 1 )
#define CUR_MODE_CONST_IS_VOLT  ( VAL_VOLT << 1 )
#define CUR_MODE_CONST_IS_WATT  ( VAL_WATT << 1 )

#endif
